<?php
/**
 * @package Acquire for Contentteller
 * @copyright (C) 2008 Esselbach Internet Solutions
 * @license GNU Lesser General Public License (LGPL)
 */

/**
 * function AdminAcquireArticles
 * A function to import articles from other CMS databases
 * @author Philipp Louis Esselbach
 */
function AdminAcquireArticles()
{
	global $database, $preferences, $html, $system, $security, $login_username, $words_acquire;
	$acquire = new acquire;
	$input_start = ( isset( $_GET[ 'input_start' ] ) ) ? $security -> checknum( $_GET[ 'input_start' ] ) : 0 ;
	$html -> makeheader( $words_acquire[ 'ACQUIRE' ] );
	$html -> makesubheader();
	$html -> makegroupmenu( "acquire" );
	$html -> makemainheader( $words_acquire[ 'ACQUIRE' ], "acquire" );
	$database -> dbclose();
	$error = $acquire -> dbconnect();
	
	if( $error )
	{
		echo $error;
	}
	else
	{
		$allarticles = $acquire -> articles();
		
		if( $allarticles )
		{
			echo $words_acquire[ 'IMPORTING' ] . " " . $allarticles . " " . $words_acquire[ 'ARTICLES' ] . "<br /><br />";
			$articles = $acquire -> articlesimport( $input_start, 20 );
			$acquire -> dbclose();
			$database -> dbconnect();
			
			if( $articles )
			{
				if( !$input_start )
				{
					$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_articles" );
					$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_articlespages" );
				}
				
				foreach( $articles as $article )
				{
					echo $words_acquire[ 'IMPORTING' ] . " " . $article[ 'review_title' ] . " (" . $article[ 'review_page' ] . ")<br />";
					$input_website = ( isset( $news_story[ 'review_website' ] ) ) ? $database -> dbescape( $news_story[ 'review_website' ] ) : 0 ;
					$input_article_author = ( isset( $article[ 'review_author' ] ) ) ? $database -> dbescape( $article[ 'review_author' ] ) : "" ;
					$input_article_id = ( isset( $article[ 'reviewpage_id' ] ) ) ? $database -> dbescape( $article[ 'reviewpage_id' ] ) : "" ;
					$input_article_pageid = ( isset( $article[ 'review_id' ] ) ) ? $database -> dbescape( $article[ 'review_id' ] ) : "" ;
					$input_article_page = ( isset( $article[ 'review_page' ] ) ) ? $database -> dbescape( $article[ 'review_page' ] ) : "" ;
					$input_article_category = ( isset( $article[ 'review_category' ] ) ) ? $database -> dbescape( $article[ 'review_category' ] ) : "" ;
					$input_article_title = ( isset( $article[ 'review_title' ] ) ) ? $database -> dbescape( $article[ 'review_title' ] ) : "" ;
					$input_article_page = ( isset( $article[ 'review_page' ] ) ) ? $database -> dbescape( $article[ 'review_page' ] ) : "" ;
					$input_article_pagetitle = ( isset( $article[ 'review_pagesup' ] ) ) ? $database -> dbescape( $article[ 'review_pagesup' ] ) : "" ;
					$input_article_pagetext = ( isset( $article[ 'review_text' ] ) ) ? $database -> dbescape( $article[ 'review_text' ] ) : "" ;
					$input_article_date = ( isset( $article[ 'review_date' ] ) ) ? $database -> dbescape( $article[ 'review_date' ] ) : "" ;
					$input_html = ( isset( $article[ 'review_html' ] ) ) ? $database -> dbescape( $article[ 'review_html' ] ) : 0 ;
					$input_smilies = ( isset( $article[ 'review_icon' ] ) ) ? $database -> dbescape( $article[ 'review_icon' ] ) : 0 ;
					$input_blockcode = ( isset( $article[ 'review_code' ] ) ) ? $database -> dbescape( $article[ 'review_code' ] ) : 0 ;
					$input_review_extra1 = ( isset( $article[ 'review_extra1' ] ) ) ? $database -> dbescape( $article[ 'review_extra1' ] ) : "" ;
					$input_review_extra2 = ( isset( $article[ 'review_extra2' ] ) ) ? $database -> dbescape( $article[ 'review_extra2' ] ) : "" ;
					$input_review_extra3 = ( isset( $article[ 'review_extra3' ] ) ) ? $database -> dbescape( $article[ 'review_extra3' ] ) : "" ;
					$input_review_extra4 = ( isset( $article[ 'review_extra4' ] ) ) ? $database -> dbescape( $article[ 'review_extra4' ] ) : "" ;
					$input_review_extra5 = ( isset( $article[ 'review_extra5' ] ) ) ? $database -> dbescape( $article[ 'review_extra5' ] ) : "" ;
					$input_review_extra6 = ( isset( $article[ 'review_extra6' ] ) ) ? $database -> dbescape( $article[ 'review_extra6' ] ) : "" ;
					$input_review_extra7 = ( isset( $article[ 'review_extra7' ] ) ) ? $database -> dbescape( $article[ 'review_extra7' ] ) : "" ;
					$input_review_extra8 = ( isset( $article[ 'review_extra8' ] ) ) ? $database -> dbescape( $article[ 'review_extra8' ] ) : "" ;
					$input_review_extra9 = ( isset( $article[ 'review_extra9' ] ) ) ? $database -> dbescape( $article[ 'review_extra9' ] ) : "" ;
					$input_review_extra10 = ( isset( $article[ 'review_extra10' ] ) ) ? $database -> dbescape( $article[ 'review_extra10' ] ) : "" ;
					$input_review_extra11 = ( isset( $article[ 'review_extra11' ] ) ) ? $database -> dbescape( $article[ 'review_extra11' ] ) : "" ;
					$input_review_extra12 = ( isset( $article[ 'review_extra12' ] ) ) ? $database -> dbescape( $article[ 'review_extra12' ] ) : "" ;
					$input_review_extra13 = ( isset( $article[ 'review_extra13' ] ) ) ? $database -> dbescape( $article[ 'review_extra13' ] ) : "" ;
					$input_review_extra14 = ( isset( $article[ 'review_extra14' ] ) ) ? $database -> dbescape( $article[ 'review_extra14' ] ) : "" ;
					$input_review_extra15 = ( isset( $article[ 'review_extra15' ] ) ) ? $database -> dbescape( $article[ 'review_extra15' ] ) : "" ;
					$input_review_extra16 = ( isset( $article[ 'review_extra16' ] ) ) ? $database -> dbescape( $article[ 'review_extra16' ] ) : "" ;
					$input_review_extra17 = ( isset( $article[ 'review_extra17' ] ) ) ? $database -> dbescape( $article[ 'review_extra17' ] ) : "" ;
					$input_review_extra18 = ( isset( $article[ 'review_extra18' ] ) ) ? $database -> dbescape( $article[ 'review_extra18' ] ) : "" ;
					$input_review_extra19 = ( isset( $article[ 'review_extra19' ] ) ) ? $database -> dbescape( $article[ 'review_extra19' ] ) : "" ;
					$input_review_extra20 = ( isset( $article[ 'review_extra20' ] ) ) ? $database -> dbescape( $article[ 'review_extra20' ] ) : "" ;
					$input_article_postip = ( isset( $article[ 'review_postip' ] ) ) ? $database -> dbescape( $article[ 'review_postip' ] ) : "" ;
					$input_article_editip = ( isset( $article[ 'review_editip' ] ) ) ? $database -> dbescape( $article[ 'review_editip' ] ) : "" ;
					$input_status = "0";
					$input_fields_encoded = base64_encode( stripslashes( $input_review_extra1 ) ) . "|" . base64_encode( stripslashes( $input_review_extra2 ) ) . "|" . base64_encode( stripslashes( $input_review_extra3 ) ) . "|" . base64_encode( stripslashes( $input_review_extra4 ) ) . "|" . base64_encode( stripslashes( $input_review_extra5 ) ) . "|" . base64_encode( stripslashes( $input_review_extra6 ) ) . "|" . base64_encode( stripslashes( $input_review_extra7 ) ) . "|" . base64_encode( stripslashes( $input_review_extra8 ) ) . "|" . base64_encode( stripslashes( $input_review_extra9 ) ) . "|" . base64_encode( stripslashes( $input_review_extra10 ) ) . "|" . base64_encode( stripslashes( $input_review_extra11 ) ) . "|" . base64_encode( stripslashes( $input_review_extra12 ) ) . "|" . base64_encode( stripslashes( $input_review_extra13 ) ) . "|" . base64_encode( stripslashes( $input_review_extra14 ) ) . "|" . base64_encode( stripslashes( $input_review_extra15 ) ) . "|" . base64_encode( stripslashes( $input_review_extra16 ) ) . "|" . base64_encode( stripslashes( $input_review_extra17 ) ) . "|" . base64_encode( stripslashes( $input_review_extra18 ) ) . "|" . base64_encode( stripslashes( $input_review_extra19 ) ) . "|" . base64_encode( stripslashes( $input_review_extra20 ) ) . "|||||";
					if ($input_website == 4) $input_website = 3;
					if ($input_website == 6) $input_website = 2;
					
					$input_article_pagetext_parsed = stripslashes( $input_article_pagetext );
					
					if( !$input_html )
					{
						$input_article_pagetext_parsed = $system -> dechomp( $input_article_pagetext_parsed );
					}
					else
					{
						$input_article_pagetext_parsed = $system -> scriptex( $input_article_pagetext_parsed );
					}
					
					if( $input_smilies )
					{
						$input_article_pagetext_parsed = $system -> smilies( $input_article_pagetext_parsed );
					}
					
					if( $input_blockcode )
					{
						$input_article_pagetext_parsed = $system -> code( $input_article_pagetext_parsed );
					}
					
					$input_article_pagetext_parsed = $database -> dbescape( $input_article_pagetext_parsed );
					$input_article_title = htmlspecialchars( $input_article_title );
					$input_article_seo = $system -> doseo( $input_article_title );
					$input_article_description = $database -> dbescape( $system -> description( $article[ 'review_text' ] ) );
					$input_article_keywords = $system -> keywords( $article[ 'review_text' ] );
					$input_article_summary = $database -> dbescape( $system -> description( $article[ 'review_text' ] ) );
					$query = $database -> dbquery( "SELECT COUNT(article_id) FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_seo = '" . $input_article_seo . "'" );
					list( $seo_articles ) = $database -> dbrow( $query );
					
					if( $seo_articles )
					{
						$input_article_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
					}
					
					if( $preferences[ 'articles_automated_tags' ] )
					{
						$input_article_tags = $system -> tags( $input_article_title );
					}
					else
					{
						$input_article_tags = "";
					}
					
					if( $input_article_page == 1 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articles (article_id, article_author, article_website, article_category, article_title, article_seo, article_rawsummary, article_summary, article_pages, article_description, article_keywords, article_tags, article_teaser, article_comments, article_allowcomments, article_thread, article_frontpage, article_html, article_smilies, article_code, article_status, article_password, article_date, article_startdate, article_expiredate, article_neverexpire, article_fields, article_sticky, article_views, article_rating, article_votes, article_activity, article_postip, article_editip, article_editadmin) VALUES ('" . $input_article_pageid . "', '" . $input_article_author . "', '" . $input_website . "', '" . $input_article_category . "', '" . $input_article_title . "', '" . $input_article_seo . "', '" . $input_article_summary . "', '" . $input_article_summary . "', '1', '" . $input_article_description . "', '" . $input_article_keywords . "', '" . $input_article_tags . "', '0', '0', '1', '0', '1', '" . $input_html . "', '" . $input_smilies . "', '" . $input_blockcode . "', '" . $input_status . "', '', '" . $input_article_date . "', '" . $input_article_date . "', '" . $input_article_date . "', '1', '" . $input_fields_encoded . "', '0', '0', '0', '0', now(), '" . $input_article_postip . "', '" . $input_article_editip . "', '" . $login_username . "')" );
						
						if( $input_article_tags )
						{
							$tags = explode( ",", $input_article_tags );
							
							foreach( $tags as $tag )
							{
								$tag_seo = $system -> doseo( $tag );
								$query = $database -> dbquery( "SELECT articletag_id FROM " . DB_PREFIX . "esselbach_ct_articlestags WHERE articletag_tag = '" . $tag . "' AND (articletag_website = '0' AND articletag_website = '" . $input_website . "')" );
								
								if( $database -> dbrows( $query ) )
								{
									$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlestags SET articletag_count = articletag_count + 1 WHERE articletag_tag = '" . $tag . "' AND (articletag_website = '0' AND articletag_website = '" . $input_website . "')" );
								}
								else
								{
									$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlestags (articletag_id, articletag_website, articletag_tag, articletag_seo, articletag_count) VALUES (NULL, '" . $input_website . "', '" . $tag . "', '" . $tag_seo . "', '1')" );
								}
							}
						}
					}
					else
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_pages = article_pages + 1 WHERE article_id = '" . $input_article_pageid . "'" );
					}
					
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlespages (articlepage_id, articlepage_article, articlepage_page, articlepage_title, articlepage_rawtext, articlepage_text, articlepage_postip, articlepage_editip, articlepage_editadmin) VALUES (NULL, '" . $input_article_pageid . "', '" . $input_article_page . "', '" . $input_article_pagetitle . "', '" . $input_article_pagetext . "', '" . $input_article_pagetext_parsed . "', '" . $input_article_postip . "', '" . $input_article_editip . "', '" . $login_username . "')" );
				}
				
				$next = $input_start + 20;
				$html -> jump( "index.php?action=acquirearticles&input_start=" . $next, 200 );
				echo "<br />";
				echo "<a href=\"index.php?action=acquirearticles&amp;input_start=" . $next . "\">" . $words_acquire[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			}
			else
			{
				echo $words_acquire[ 'IMPORT_COMPLETED' ] . " <a href=\"index.php?action=acquirenow\">" . $words_acquire[ 'CLICK_HERE' ] . "</a> " . $words_acquire[ 'BACK_TO_OVERVIEW' ];
			}
		}
		else
		{
			$acquire -> dbclose();
			$database -> dbconnect();
		}
		
		$html -> maketablefooter();
		$html -> makesubfooter();
		$html -> makesubfooter();
	}
}
?>