<?php
/**
 * @package Acquire for Contentteller
 * @copyright (C) 2008 Esselbach Internet Solutions
 * @license GNU Lesser General Public License (LGPL)
 */

/**
 * function AdminAcquireFiles
 * A function to import files from other CMS databases
 * @author Philipp Louis Esselbach
 */
function AdminAcquireFiles()
{
	global $database, $preferences, $html, $system, $security, $login_username, $words_acquire;
	$acquire = new acquire;
	$input_start = ( isset( $_GET[ 'input_start' ] ) ) ? $security -> checknum( $_GET[ 'input_start' ] ) : 0 ;
	$html -> makeheader( $words_acquire[ 'ACQUIRE' ] );
	$html -> makesubheader();
	$html -> makegroupmenu( "acquire" );
	$html -> makemainheader( $words_acquire[ 'ACQUIRE' ], "acquire" );
	$database -> dbclose();
	$error = $acquire -> dbconnect();
	
	if( $error )
	{
		echo $error;
	}
	else
	{
		$allfiles = $acquire -> files();
		
		if( $allfiles )
		{
			echo $words_acquire[ 'IMPORTING' ] . " " . $allfiles . " " . $words_acquire[ 'FILES' ] . "<br /><br />";
			$files = $acquire -> filesimport( $input_start, 20 );
			$acquire -> dbclose();
			$database -> dbconnect();
			
			if( $files )
			{
				if( !$input_start )
				{
					$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_files" );
					$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_filesdownloads" );
				}
				
				foreach( $files as $file )
				{
					echo $words_acquire[ 'IMPORTING' ] . " " . $file[ 'download_title' ] . "<br />";
					$input_website = ( isset( $file[ 'download_website' ] ) ) ? $database -> dbescape( $file[ 'download_website' ] ) : 0 ;
					$input_file_author = ( isset( $file[ 'download_author' ] ) ) ? $database -> dbescape( $file[ 'download_author' ] ) : "" ;
					$input_file_id = ( isset( $file[ 'download_id' ] ) ) ? $database -> dbescape( $file[ 'download_id' ] ) : "" ;
					$input_file_category = ( isset( $file[ 'download_category' ] ) ) ? $database -> dbescape( $file[ 'download_category' ] ) : "" ;
					$input_file_name = ( isset( $file[ 'download_title' ] ) ) ? $database -> dbescape( $file[ 'download_title' ] ) : "" ;
					$input_file_smalldescription = ( isset( $file[ 'download_text' ] ) ) ? $database -> dbescape( $file[ 'download_text' ] ) : "" ;
					$input_file_longdescription = ( isset( $file[ 'download_extendedtext' ] ) ) ? $database -> dbescape( $file[ 'download_extendedtext' ] ) : "" ;
					$input_file_comments = ( isset( $file[ 'download_comments' ] ) ) ? $database -> dbescape( $file[ 'download_comments' ] ) : 0 ;
					$input_file_allowcomments = ( isset( $file[ 'download_comm' ] ) ) ? $database -> dbescape( $file[ 'download_comm' ] ) : 0 ;
					$input_file_views = ( isset( $file[ 'download_count' ] ) ) ? $database -> dbescape( $file[ 'download_count' ] ) : 0 ;
					$input_file_date = ( isset( $file[ 'download_time' ] ) ) ? $database -> dbescape( $file[ 'download_time' ] ) : "" ;
					$input_file_url_1 = ( isset( $file[ 'download_url1' ] ) ) ? $database -> dbescape( $file[ 'download_url1' ] ) : "" ;
					$input_file_url_2 = ( isset( $file[ 'download_url2' ] ) ) ? $database -> dbescape( $file[ 'download_url2' ] ) : "" ;
					$input_file_url_3 = ( isset( $file[ 'download_url3' ] ) ) ? $database -> dbescape( $file[ 'download_url3' ] ) : "" ;
					$input_file_url_4 = ( isset( $file[ 'download_url4' ] ) ) ? $database -> dbescape( $file[ 'download_url4' ] ) : "" ;
					$input_file_url_5 = ( isset( $file[ 'download_url5' ] ) ) ? $database -> dbescape( $file[ 'download_url5' ] ) : "" ;
					$input_file_url_6 = ( isset( $file[ 'download_url6' ] ) ) ? $database -> dbescape( $file[ 'download_url6' ] ) : "" ;
					$input_file_url_7 = ( isset( $file[ 'download_url7' ] ) ) ? $database -> dbescape( $file[ 'download_url7' ] ) : "" ;
					$input_file_url_8 = ( isset( $file[ 'download_url8' ] ) ) ? $database -> dbescape( $file[ 'download_url8' ] ) : "" ;
					$input_html = ( isset( $file[ 'download_html' ] ) ) ? $database -> dbescape( $file[ 'download_html' ] ) : 0 ;
					$input_smilies = ( isset( $file[ 'download_icon' ] ) ) ? $database -> dbescape( $file[ 'download_icon' ] ) : 0 ;
					$input_blockcode = ( isset( $file[ 'download_code' ] ) ) ? $database -> dbescape( $file[ 'download_code' ] ) : 0 ;
					$input_download_extra1 = ( isset( $file[ 'download_extra1' ] ) ) ? $database -> dbescape( $file[ 'download_extra1' ] ) : "" ;
					$input_download_extra2 = ( isset( $file[ 'download_extra2' ] ) ) ? $database -> dbescape( $file[ 'download_extra2' ] ) : "" ;
					$input_download_extra3 = ( isset( $file[ 'download_extra3' ] ) ) ? $database -> dbescape( $file[ 'download_extra3' ] ) : "" ;
					$input_download_extra4 = ( isset( $file[ 'download_extra4' ] ) ) ? $database -> dbescape( $file[ 'download_extra4' ] ) : "" ;
					$input_download_extra5 = ( isset( $file[ 'download_extra5' ] ) ) ? $database -> dbescape( $file[ 'download_extra5' ] ) : "" ;
					$input_download_extra6 = ( isset( $file[ 'download_extra6' ] ) ) ? $database -> dbescape( $file[ 'download_extra6' ] ) : "" ;
					$input_download_extra7 = ( isset( $file[ 'download_extra7' ] ) ) ? $database -> dbescape( $file[ 'download_extra7' ] ) : "" ;
					$input_download_extra8 = ( isset( $file[ 'download_extra8' ] ) ) ? $database -> dbescape( $file[ 'download_extra8' ] ) : "" ;
					$input_download_extra9 = ( isset( $file[ 'download_extra9' ] ) ) ? $database -> dbescape( $file[ 'download_extra9' ] ) : "" ;
					$input_download_extra10 = ( isset( $file[ 'download_extra10' ] ) ) ? $database -> dbescape( $file[ 'download_extra10' ] ) : "" ;
					$input_download_extra11 = ( isset( $file[ 'download_extra11' ] ) ) ? $database -> dbescape( $file[ 'download_extra11' ] ) : "" ;
					$input_download_extra12 = ( isset( $file[ 'download_extra12' ] ) ) ? $database -> dbescape( $file[ 'download_extra12' ] ) : "" ;
					$input_download_extra13 = ( isset( $file[ 'download_extra13' ] ) ) ? $database -> dbescape( $file[ 'download_extra13' ] ) : "" ;
					$input_download_extra14 = ( isset( $file[ 'download_extra14' ] ) ) ? $database -> dbescape( $file[ 'download_extra14' ] ) : "" ;
					$input_download_extra15 = ( isset( $file[ 'download_extra15' ] ) ) ? $database -> dbescape( $file[ 'download_extra15' ] ) : "" ;
					$input_download_extra16 = ( isset( $file[ 'download_extra16' ] ) ) ? $database -> dbescape( $file[ 'download_extra16' ] ) : "" ;
					$input_download_extra17 = ( isset( $file[ 'download_extra17' ] ) ) ? $database -> dbescape( $file[ 'download_extra17' ] ) : "" ;
					$input_download_extra18 = ( isset( $file[ 'download_extra18' ] ) ) ? $database -> dbescape( $file[ 'download_extra18' ] ) : "" ;
					$input_download_extra19 = ( isset( $file[ 'download_extra19' ] ) ) ? $database -> dbescape( $file[ 'download_extra19' ] ) : "" ;
					$input_download_extra20 = ( isset( $file[ 'download_extra20' ] ) ) ? $database -> dbescape( $file[ 'download_extra20' ] ) : "" ;
					$input_file_postip = ( isset( $file[ 'download_postip' ] ) ) ? $database -> dbescape( $file[ 'download_postip' ] ) : "" ;
					$input_file_editip = ( isset( $file[ 'download_editip' ] ) ) ? $database -> dbescape( $file[ 'download_editip' ] ) : "" ;
					$input_status = "0";
					$input_file_seo = $system -> doseo( $file[ 'download_title' ] );
					$input_file_description = $database -> dbescape( $system -> description( $file[ 'download_text' ] ) );
					$input_file_keywords = $system -> keywords( $file[ 'download_text' ] );
					$input_file_smalldescription_parsed = stripslashes( $input_file_smalldescription );
					$input_file_longdescription_parsed = stripslashes( $input_file_longdescription );
					
					if ($input_website == 4) $input_website = 3;
					if ($input_website == 6) $input_website = 2;
										
					if( !$input_html )
					{
						$input_file_smalldescription_parsed = $system -> dechomp( $input_file_smalldescription_parsed );
						$input_file_longdescription_parsed = $system -> dechomp( $input_file_longdescription_parsed );
					}
					else
					{
						$input_file_smalldescription_parsed = $system -> scriptex( $input_file_smalldescription_parsed );
						$input_file_longdescription_parsed = $system -> scriptex( $input_file_longdescription_parsed );
					}
					
					if( $input_smilies )
					{
						$input_file_smalldescription_parsed = $system -> smilies( $input_file_smalldescription_parsed );
						$input_file_longdescription_parsed = $system -> smilies( $input_file_longdescription_parsed );
					}
					
					if( $input_blockcode )
					{
						$input_file_smalldescription_parsed = $system -> code( $input_file_smalldescription_parsed );
						$input_file_longdescription_parsed = $system -> code( $input_file_longdescription_parsed );
					}
					
					$input_file_smalldescription_parsed = $database -> dbescape( $input_file_smalldescription_parsed );
					$input_file_longdescription_parsed = $database -> dbescape( $input_file_longdescription_parsed );
					$input_fields_encoded = base64_encode( stripslashes( $input_download_extra1 ) ) . "|" . base64_encode( stripslashes( $input_download_extra2 ) ) . "|" . base64_encode( stripslashes( $input_download_extra3 ) ) . "|" . base64_encode( stripslashes( $input_download_extra4 ) ) . "|" . base64_encode( stripslashes( $input_download_extra5 ) ) . "|" . base64_encode( stripslashes( $input_download_extra6 ) ) . "|" . base64_encode( stripslashes( $input_download_extra7 ) ) . "|" . base64_encode( stripslashes( $input_download_extra8 ) ) . "|" . base64_encode( stripslashes( $input_download_extra9 ) ) . "|" . base64_encode( stripslashes( $input_download_extra10 ) ) . "|" . base64_encode( stripslashes( $input_download_extra11 ) ) . "|" . base64_encode( stripslashes( $input_download_extra12 ) ) . "|" . base64_encode( stripslashes( $input_download_extra13 ) ) . "|" . base64_encode( stripslashes( $input_download_extra14 ) ) . "|" . base64_encode( stripslashes( $input_download_extra15 ) ) . "|" . base64_encode( stripslashes( $input_download_extra16 ) ) . "|" . base64_encode( stripslashes( $input_download_extra17 ) ) . "|" . base64_encode( stripslashes( $input_download_extra18 ) ) . "|" . base64_encode( stripslashes( $input_download_extra19 ) ) . "|" . base64_encode( stripslashes( $input_download_extra20 ) ) . "|||||";
					$input_file_name = htmlspecialchars( $input_file_name );
					
					if( !$input_file_seo )
					{
						$input_file_seo = $input_file_name;
					}
					
					$input_file_seo = $system -> doseo( $input_file_seo );
					$query = $database -> dbquery( "SELECT COUNT(file_id) FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $input_file_seo . "'" );
					list( $seo_files ) = $database -> dbrow( $query );
					
					if( $seo_files )
					{
						$input_file_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
					}
					
					if( $preferences[ 'files_automated_tags' ] )
					{
						$input_file_tags = $system -> tags( $input_file_name );
					}
					else
					{
						$input_file_tags = "";
					}
					
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_files (file_id, file_author, file_website, file_category, file_name, file_version, file_seo, file_pad, file_paddate, file_rawsmalldescription, file_smalldescription, file_rawlongdescription, file_longdescription, file_description, file_keywords, file_tags, file_size, file_cost, file_company, file_homepage, file_email, file_language, file_os, file_changeinfo, file_agreement, file_teaser, file_comments, file_allowcomments, file_thread, file_frontpage, file_html, file_smilies, file_code, file_status, file_password, file_date, file_startdate, file_expiredate, file_neverexpire, file_fields, file_sticky, file_views, file_downloads, file_rating, file_votes, file_activity, file_postip, file_editip, file_editadmin) VALUES ('" . $input_file_id . "', '" . $input_file_author . "', '" . $input_website . "', '" . $input_file_category . "', '" . $input_file_name . "', '', '" . $input_file_seo . "', '', now(), '" . $input_file_smalldescription . "', '" . $input_file_smalldescription_parsed . "', '" . $input_file_longdescription . "', '" . $input_file_longdescription_parsed . "', '" . $input_file_description . "', '" . $input_file_keywords . "', '" . $input_file_tags . "', '', '', '', '', '', '1', '', '', '', '0', '" . $input_file_comments . "', '" . $input_file_allowcomments . "', '0', '1', '" . $input_html . "', '" . $input_smilies . "', '" . $input_blockcode . "', '" . $input_status . "', '', '" . $input_file_date . "', '" . $input_file_date . "', '" . $input_file_date . "', '1', '" . $input_fields_encoded . "', '0', '" . $input_file_views . "', '0', '0', '0', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					
					if( $input_file_url_1 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '1', 'Mirror 1', '" . $input_file_url_1 . "', '0', '1', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_2 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '2', 'Mirror 2', '" . $input_file_url_2 . "', '0', '2', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_3 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '3', 'Mirror 3', '" . $input_file_url_3 . "', '0', '3', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_4 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '4', 'Mirror 4', '" . $input_file_url_4 . "', '0', '4', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_5 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '5', 'Mirror 5', '" . $input_file_url_5 . "', '0', '5', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_6 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '6', 'Mirror 6', '" . $input_file_url_6 . "', '0', '6', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_7 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '7', 'Mirror 7', '" . $input_file_url_7 . "', '0', '7', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $input_file_url_8 )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesdownloads (filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position, filedownload_activity, filedownload_postip, filedownload_editip, filedownload_editadmin) VALUES (NULL, '" . $input_file_id . "', '8', 'Mirror 8', '" . $input_file_url_8 . "', '0', '1', now(), '" . $input_file_postip . "', '" . $input_file_editip . "', '" . $login_username . "')" );
					}
					
					if( $preferences[ 'files_related' ] )
					{
						$files_search = substr( $input_file_name, 0, 8 );
						$files_limit = $database -> dbescape( $preferences[ 'files_max_related' ] );
						$currentdate = date( "Y-m-d H:i:s", gmmktime() );
						
						if( !$files_limit )
						{
							$files_limit = 1;
						}
						else
						{
							$files_limit++;
						}
						
						$query = $database -> dbquery( "SELECT file_id, file_author, file_name, file_seo, file_description, file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE (file_name LIKE '%" . $files_search . "%') AND file_status = '0' AND file_website = '" . $input_website . "' AND file_startdate > '" . $currentdate . "' AND file_neverexpire = '1' ORDER BY file_date DESC LIMIT " . intval( $files_limit ) );
						
						if( $database -> dbrows( $query ) > 1 )
						{
							while( list( $filerelated_fileid, $filerelated_author, $filerelated_name, $filerelated_seo, $filerelated_description, $filerelated_date ) = $database -> dbrow( $query ) )
							{
								$filerelated_author = $database -> dbescape( $filerelated_author );
								$filerelated_name = $database -> dbescape( $filerelated_name );
								$filerelated_description = $database -> dbescape( $filerelated_description );
								
								if( $filerelated_fileid != $input_file_id )
								{
									$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesrelated (fileelated_id, filerelated_file, filerelated_fileid, filerelated_author, filerelated_website, filerelated_name, filerelated_seo, filerelated_description, filerelated_date) VALUES (NULL, '" . $input_file_id . "', '" . $filerelated_fileid . "', '" . $filerelated_author . "', '" . $input_website . "', '" . $filerelated_name . "', '" . $filerelated_seo . "', '" . $filerelated_description . "', '" . $filerelated_date . "')" );
								}
							}
						}
					}
					
					if( $input_file_tags )
					{
						$tags = explode( ",", $input_file_tags );
						
						foreach( $tags as $tag )
						{
							$tag_seo = $system -> doseo( $tag );
							$query = $database -> dbquery( "SELECT filetag_id FROM " . DB_PREFIX . "esselbach_ct_filestags WHERE filetag_tag = '" . $tag . "' AND (filetag_website = '0' AND filetag_website = '" . $input_website . "')" );
							
							if( $database -> dbrows( $query ) )
							{
								$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filestags SET filetag_count = filetag_count + 1 WHERE filetag_tag = '" . $tag . "' AND (filetag_website = '0' AND filetag_website = '" . $input_website . "')" );
							}
							else
							{
								$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filestags (filetag_id, filetag_website, filetag_tag, filetag_seo, filetag_count) VALUES (NULL, '" . $input_website . "', '" . $tag . "', '" . $tag_seo . "', '1')" );
							}
						}
					}
				}
				
				$next = $input_start + 20;
				$html -> jump( "index.php?action=acquirefiles&input_start=" . $next, 200 );
				echo "<br />";
				echo "<a href=\"index.php?action=acquirefiles&amp;input_start=" . $next . "\">" . $words_acquire[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			}
			else
			{
				echo $words_acquire[ 'IMPORT_COMPLETED' ] . " <a href=\"index.php?action=acquirenow\">" . $words_acquire[ 'CLICK_HERE' ] . "</a> " . $words_acquire[ 'BACK_TO_OVERVIEW' ];
			}
		}
		else
		{
			$acquire -> dbclose();
			$database -> dbconnect();
		}
		
		$html -> maketablefooter();
		$html -> makesubfooter();
		$html -> makesubfooter();
	}
}
?>